package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.WXMediaMapper;
import com.sa.ibiz.demo.demo.domain.WXMedia;
import com.sa.ibiz.demo.demo.service.WXMediaService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.WXMediaSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.WXAccountService;
import com.sa.ibiz.demo.demo.service.WXEntAppService;

/**
 * 实体[WXMedia] 服务对象接口实现
 */
@Service
public class WXMediaServiceImpl extends ServiceImplBase<WXMediaMapper, WXMedia> implements WXMediaService{

    @Autowired
    private WXAccountService wxaccountService;
    @Autowired
    private WXEntAppService wxentappService;

    @Resource
    private WXMediaMapper wxmediaMapper;


    @Override
    public boolean create(WXMedia et) {
        this.beforeCreate(et);
         return super.create(et);
    }
    @Override
    public boolean update(WXMedia et){
        this.beforeUpdate(et);
		this.wxmediaMapper.updateOne(et);
		this.get(et);
		return true;
    }

    public Object getEntityKey(WXMedia et){
		return et.getWxmediaid();  
    }

    @Override
    public boolean getDraft(WXMedia et)  {
    if((!StringUtils.isEmpty(et.getWxaccountid())) && et.getWxaccount() == null){
            try {
                et.setWxaccount(wxaccountService.getById(et.getWxaccountid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getWxentappid())) && et.getWxentapp() == null){
            try {
                et.setWxentapp(wxentappService.getById(et.getWxentappid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<WXMedia> listDefault(WXMediaSearchFilter filter) {
		return wxmediaMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<WXMedia> searchDefault(WXMediaSearchFilter filter) {
		return wxmediaMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return wxmediaMapper.selectRow(sql);
    }

 }